# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_without dev
%bcond_with jdk6
%bcond_with gcj_support
%bcond_with native
%bcond_without upstream
%bcond_without zips

%if %with native
%bcond_without dev
%endif

%if %with gcj_support
%define gcj_support 1
%else
%define gcj_support 0
%endif

%define svnrev          5229M
%define mozver          1.7.13
%define swtver          3235
%define section         free

Name:           gwt
Version:        1.6.4
Release:        0.9%{?dist}
Epoch:          0
Summary:        Google Web Toolkit
License:        ASL 2.0
Group:          Development/Libraries/Java
URL:            http://code.google.com/webtoolkit/
# svn -q export http://google-web-toolkit.googlecode.com/svn/tags/1.6.4/ gwt-1.6.4 && tar cjf gwt-1.6.4.tar.bz2 gwt-1.6.4
Source0:        gwt-1.6.4.tar.bz2
# svn -q export http://google-web-toolkit.googlecode.com/svn/tools/ tools && tar cjf gwt-tools.tar.bz2 tools
Source1:        gwt-tools.tar.bz2
Source2:        http://mirrors.ibiblio.org/pub/mirrors/maven2/com/google/gwt/gwt-dev/1.6.4/gwt-dev-1.6.4.pom
Source3:        http://mirrors.ibiblio.org/pub/mirrors/maven2/com/google/gwt/gwt-servlet/1.6.4/gwt-servlet-1.6.4.pom
Source4:        http://mirrors.ibiblio.org/pub/mirrors/maven2/com/google/gwt/gwt-user/1.6.4/gwt-user-1.6.4.pom
Patch0:         gwt-build.patch
Patch1:         gwt-java6.patch
Requires(post): jpackage-utils >= 0:1.7.3
Requires(postun): jpackage-utils >= 0:1.7.3
BuildRequires:  ant
BuildRequires:  jboss-javaee-javadoc
BuildRequires:  junit-javadoc
BuildRequires:  tomcat6-servlet-2.5-api
BuildRequires:  xml-commons-jaxp-1.3-apis
BuildRequires:  xerces-j2
%if %{gcj_support}
BuildRequires:  java-gcj-compat-devel
%else
BuildArch:      noarch
BuildRequires:	java-devel
%endif
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
Writing web apps today is a tedious and error-prone process.
Developers can spend 90% of their time working around browser
quirks. In addition, building, reusing, and maintaining large
JavaScript code bases and AJAX components can be difficult and
fragile. Google Web Toolkit (GWT) eases this burden by allowing
developers to quickly build and maintain complex yet highly
performant JavaScript front-end applications in the Java
programming language.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
Javadoc for %{name}.

%package demo
Summary:        Samples for %{name}
Group:          Development/Libraries/Java
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description demo
Samples for %{name}.

%if %with dev
%package devel
Summary:        Support for the GWT Java to javascript compiler and the hosted mode runtime
Group:          Development/Libraries/Java
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description devel
Support for the GWT Java to javascript compiler and the hosted mode runtime.
%endif

%if %with zips
%package zip
Summary:     Container for the zipped distribution of %{name}
Group:       Development

%description zip
Container for the zipped distribution of %{name}.

%package src-zip
Summary:     Container for the sources of %{name}
Group:       Development

%description src-zip
Container for the sources of %{name}.
%endif

%prep
%setup -q
%patch0 -p0
%if %with jdk6
%patch1 -p0
%endif
%if %with upstream
%setup -q -T -D -a 1
# XXX: (dwalluck): Google's jar also contains the .java files
%{__rm} tools/lib/tomcat/servlet-api-2.5.jar
%{__cp} -p $(build-classpath tomcat6-servlet-2.5-api) tools/lib/tomcat/servlet-api-2.5.jar
%endif

%{__perl} -pi -e 's/mozilla-1\.7\.12\.tar\.gz/mozilla-%{mozver}.tar.gz/;' distro-source/linux/build.xml

%if %without native
%{__rm} \
        distro-source/linux/src/mozilla-hosted-browser.conf \
        distro-source/linux/src/benchmarkViewer \
        distro-source/linux/src/junitCreator \
        distro-source/linux/src/i18nCreator \
        distro-source/linux/src/webAppCreator \
        distro-source/windows/src/benchmarkViewer.cmd \
        distro-source/windows/src/i18nCreator.cmd \
        distro-source/windows/src/junitCreator.cmd \
        distro-source/windows/src/webAppCreator.cmd \
        jni/linux/prebuilt/libgwt-ll.so \
        jni/windows/prebuilt/gwt-ll.dll \
        tools/lib/eclipse/libswt-gtk-%{swtver}.so \
        tools/lib/eclipse/libswt-mozilla-gcc3-gtk-%{swtver}.so \
        tools/lib/eclipse/libswt-mozilla-gtk-%{swtver}.so \
        tools/lib/eclipse/libswt-mozilla17-profile-gcc3-gtk-%{swtver}.so \
        tools/lib/eclipse/libswt-mozilla17-profile-gtk-%{swtver}.so \
        tools/lib/eclipse/libswt-pi-gtk-%{swtver}.so \
        tools/lib/eclipse/swt-win32-%{swtver}.dll \
        tools/sdk/mozilla-1.7.13/lib/libxpcomglue_s.a \
        tools/sdk/mozilla-1.7.12/lib/libxpcomglue_s.a
%endif

%if %with zips
%{__mkdir_p} %{name}-%{version}
%{__cp} -pr branch-info.txt build-tools build.xml common.ant.xml dev dev-ext distro-source doc eclipse jni platforms.ant.xml reference samples servlet user tools %{name}-%{version}/
%{_bindir}/zip -q -9 -r %{name}-%{version}-src.zip %{name}-%{version}/
%{__rm} -r %{name}-%{version}/
%endif

%build
export CLASSPATH=
export OPT_JAR_LIST=:
export GWT_TOOLS=`pwd`/tools
export GWT_VERSION=%{version}
export ANT_OPTS="-Xms1g -Xmx1g"
%{ant} -Dbuild.sysclasspath=first -Dgwt.svnrev=@%{svnrev} -Dgwt.svnrev.filename=%{svnrev}

%install
%{__rm} -rf %{buildroot}

%{__rm} -rf %{name}-%{version}

%{__tar} xjf build/dist/gwt-linux-%{version}.tar.bz2

%if %without native
%{__rm} -r gwt-linux-%{version}/mozilla-%{mozver}/
%endif

%if %without dev
%{__rm} gwt-linux-%{version}/gwt-dev-linux.jar \
    build/staging/gwt-linux-%{version}/gwt-dev-linux.jar \
    build/lib/gwt-dev-linux.jar
%endif

%{__mv} gwt-linux-%{version} %{name}-%{version}

%if %with zips
%{_bindir}/zip -q -9 -r %{name}-%{version}.zip %{name}-%{version}/
%endif

pushd gwt-%{version}/

%{__mkdir_p} %{buildroot}%{_datadir}/%{name}/
%{__cp} -pr * %{buildroot}%{_datadir}/%{name}/

# jar
%{__mkdir_p} %{buildroot}%{_javadir}/%{name}/
for jar in *.jar; do
    newjar=`echo $(basename ${jar} .jar) | sed 's/gwt-//'`
    %{__cp} -p ${jar} %{buildroot}%{_javadir}/%{name}/${newjar}-%{version}.jar
    %{__ln_s} %{name}/${newjar}-%{version}.jar %{buildroot}%{_javadir}/%{name}-${newjar}-%{version}.jar
done
(cd %{buildroot}%{_javadir} && for jar in *-%{version}*; do %{__ln_s} ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)
(cd %{buildroot}%{_javadir}/%{name} && for jar in *-%{version}*; do %{__ln_s} ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

%if %with native
# etc
%{__mkdir_p} %{buildroot}%{_sysconfdir}/%{name}
%{__mv} %{buildroot}%{_datadir}/%{name}/mozilla-hosted-browser.conf %{buildroot}%{_sysconfdir}/%{name}/mozilla-hosted-browser.conf
%{__ln_s} %{_sysconfdir}/%{name}/mozilla-hosted-browser.conf %{buildroot}%{_datadir}/%{name}/mozilla-hosted-browser.conf
%endif

# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/%{name}-%{version}
%{__cp} -pr doc/javadoc/* %{buildroot}%{_javadocdir}/%{name}-%{version}
%{__ln_s} %{name}-%{version} %{buildroot}%{_javadocdir}/%{name}
pushd %{buildroot}%{_datadir}/%{name}/
%{__rm} -r doc/javadoc
%{__ln_s} %{_javadocdir}/%{name} doc/javadoc
popd

## documentation
install -dm 755 %{buildroot}%{_docdir}/%{name}-%{version}
%{__cp} -pr ../branch-info.txt %{buildroot}%{_docdir}/%{name}-%{version}
%{__cp} -pr doc/helpInfo %{buildroot}%{_docdir}/%{name}-%{version}
pushd %{buildroot}%{_datadir}/%{name}
rm -Rf doc/helpInfo
%{__ln_s} %{_docdir}/%{name}-%{version}/helpInfo doc/helpInfo
popd
##

%if %with native
# scripts
%{__mkdir_p} %{buildroot}%{_bindir}/
pushd %{buildroot}%{_datadir}/%{name}/
for script in benchmarkViewer i18nCreator junitCreator webAppCreator; do
    %{__mv} ${script} %{buildroot}%{_bindir}/${script}
    %{__perl} -pi \
      -e 's|^APPDIR=.*$|APPDIR=%{_datadir}/%{name}|;' \
      -e 's|^HOMEDIR=.*$|HOMEDIR=%{_datadir}/%{name}|;' \
      %{buildroot}%{_bindir}/${script}
    %{__ln_s} %{_bindir}/${script} ${script}
done
popd
%endif
popd

# maven
%{__mkdir_p} %{buildroot}%{_datadir}/maven2/poms
%if %with dev
%{__cp} -p %{SOURCE2} %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-dev-linux.pom
%{__perl} -pi -e 's/gwt-dev/gwt-dev-linux/g' %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-dev-linux.pom
%add_to_maven_depmap com.google.gwt gwt-dev-linux %{version} JPP/%{name} dev-linux
%endif
%{__cp} -p %{SOURCE3} %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-servlet.pom
%add_to_maven_depmap com.google.gwt gwt-servlet %{version} JPP/%{name} servlet
%{__cp} -p %{SOURCE4} %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-user.pom
%add_to_maven_depmap com.google.gwt gwt-user %{version} JPP/%{name} user

%if %with zips
%{__mkdir_p} %{buildroot}%{_javadir}/jbossas-fordev
%if %with native
%{__install} -p -m 0644 build/dist/gwt-linux-%{version}.tar.bz2 %{buildroot}%{_javadir}/jbossas-fordev/gwt-linux-%{version}.tar.bz2
%{__install} -p -m 0644 build/dist/gwt-windows-%{version}.zip %{buildroot}%{_javadir}/jbossas-fordev/gwt-windows-%{version}.zip
%{__install} -p -m 0644 build/dist/gwt-mac-%{version}.tar.gz %{buildroot}%{_javadir}/jbossas-fordev/gwt-mac-%{version}.tar.gz
%else
%{__install} -p -m 0644 %{name}-%{version}.zip %{buildroot}%{_javadir}/jbossas-fordev/%{name}-%{version}.zip
%endif
%{__install} -p -m 0644 %{name}-%{version}-src.zip %{buildroot}%{_javadir}/jbossas-fordev/%{name}-%{version}-src.zip
%endif

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%clean
%{__rm} -rf %{buildroot}

%post
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%postun
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(0644,root,root,0755)
#%doc branch-info.txt Already copied to docdir
%dir %{_datadir}/%{name}
%{_datadir}/%{name}/COPYING
%{_datadir}/%{name}/COPYING.html
%{_datadir}/%{name}/about.html
%{_datadir}/%{name}/about.txt
%doc %{_docdir}/%{name}-%{version}
%{_datadir}/%{name}/doc/javadoc
%{_datadir}/%{name}/doc/helpInfo
%{_datadir}/%{name}/gwt-api-checker.jar
%{_datadir}/%{name}/gwt-benchmark-viewer.war
%{_datadir}/%{name}/gwt-module.dtd
%{_datadir}/%{name}/gwt-servlet.jar
%{_datadir}/%{name}/gwt-user.jar
%{_datadir}/%{name}/index.html
%{_datadir}/%{name}/release_notes.html
%{_datadir}/maven2/poms/JPP.%{name}-servlet.pom
%{_datadir}/maven2/poms/JPP.%{name}-user.pom
%exclude %{_datadir}/%{name}/samples
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/api-checker-%{version}.jar
%{_javadir}/%{name}/api-checker.jar
%{_javadir}/%{name}/servlet-%{version}.jar
%{_javadir}/%{name}/servlet.jar
%{_javadir}/%{name}/user-%{version}.jar
%{_javadir}/%{name}/user.jar
%{_javadir}/gwt-api-checker-%{version}.jar
%{_javadir}/gwt-api-checker.jar
%{_javadir}/gwt-servlet-%{version}.jar
%{_javadir}/gwt-servlet.jar
%{_javadir}/gwt-user-%{version}.jar
%{_javadir}/gwt-user.jar
%{_mavendepmapfragdir}/%{name}
%if %{gcj_support}
%dir %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/*
%endif

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%files demo
%defattr(0644,root,root,0755)
%{_datadir}/%{name}/samples

%if %with dev
%files devel
%defattr(0644,root,root,0755)
%{_datadir}/%{name}/gwt-dev-linux.jar
%{_datadir}/maven2/poms/JPP.%{name}-dev-linux.pom
%{_javadir}/gwt-dev-linux-%{version}.jar
%{_javadir}/gwt-dev-linux.jar
%{_javadir}/%{name}/dev-linux-%{version}.jar
%{_javadir}/%{name}/dev-linux.jar
%if %with native
%attr(0755,root,root) %{_bindir}/benchmarkViewer
%attr(0755,root,root) %{_bindir}/i18nCreator
%attr(0755,root,root) %{_bindir}/junitCreator
%attr(0755,root,root) %{_bindir}/webAppCreator
%{_datadir}/%{name}/benchmarkViewer
%{_datadir}/%{name}/i18nCreator
%{_datadir}/%{name}/junitCreator
%{_datadir}/%{name}/mozilla-hosted-browser.conf
%{_datadir}/%{name}/webAppCreator
%dir %{_sysconfdir}/%{name}
%config(noreplace) %{_sysconfdir}/%{name}/mozilla-hosted-browser.conf
%endif
%endif

%if %with zips
%files zip
%defattr(0644,jboss,jboss,0755)
%dir %{_javadir}/jbossas-fordev
%if %without native
%{_javadir}/jbossas-fordev/gwt-%{version}.zip
%else
%{_javadir}/jbossas-fordev/gwt-linux-%{version}.tar.bz2
%{_javadir}/jbossas-fordev/gwt-windows-%{version}.zip
%{_javadir}/jbossas-fordev/gwt-mac-%{version}.tar.gz
%endif

%files src-zip
%defattr(0644,jboss,jboss,0755)
%dir %{_javadir}/jbossas-fordev
%{_javadir}/jbossas-fordev/%{name}-%{version}-src.zip
%endif

%changelog
* Tue May 05 2009 Martha Benitez <mbenitez@redhat.com> 0:1.6.4-0.9
- Change location of manual files.

* Mon May 04 2009 Martha Benitez <mbenitez@redhat.com> 0:1.6.4-0.8
- Install manual files directly to docdir instead of temporary directory.

* Mon May 04 2009 David Walluck <dwalluck@redhat.com> 0:1.6.4-0.7
- add devel package

* Mon May 04 2009 David Walluck <dwalluck@redhat.com> 0:1.6.4-0.6
- use built tomcat6-servlet-2.5-api

* Fri May 01 2009 Martha Benitez <mbenitez@redhat.com> 0:1.6.4-0.5
- Move documentation to docdir
- Add BR java-devel
- Create symlink to documentation in datadir

* Fri Apr 17 2009 David Walluck <dwalluck@redhat.com> 0:1.6.4-0.4
- remove windows versions of scripts

* Fri Apr 17 2009 David Walluck <dwalluck@redhat.com> 0:1.6.4-0.3
- add options to remove gwt-dev and native bits

* Tue Apr 14 2009 David Walluck <dwalluck@redhat.com> 0:1.6.4-0.2
- 1.6.4 (1.6) SVN@5229M

* Thu Apr 09 2009 David Walluck <dwalluck@redhat.com> 0:1.6.4-0.1
- 1.6.4 (1.6)
- use mozilla 1.7.13 for build instead of 1.7.12

* Tue Mar 31 2009 David Walluck <dwalluck@redhat.com> 0:1.6.3-0.2
- include some documentation
- fix copying of src zip
- add zips for all platforms

* Tue Mar 31 2009 David Walluck <dwalluck@redhat.com> 0:1.6.3-0.1
- 1.6.3 (1.6 RC2)

* Fri Mar 27 2009 David Walluck <dwalluck@redhat.com> 0:1.6.0-0.RC.0.2
- add bin and src zips

* Thu Mar 26 2009 David Walluck <dwalluck@redhat.com> 0:1.6.0-0.RC.0.1
- a noarch package must not reference %%{_libdir}

* Thu Mar 26 2009 David Walluck <dwalluck@redhat.com> 0:1.6.0-0.RC.0.0.1
- 1.6 RC

* Mon Mar 23 2009 David Walluck <dwalluck@redhat.com> 0:1.6.0-0.M2.0.1
- release
